<?php
namespace Teknisa\FIS\Controllers;

use Teknisa\FIS\Services\Fis07200LivroMagneticoService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;

class Fis07200LivroMagneticoController extends \Teknisa\FIS\Controllers\TeknisaCrud{

    public function __construct($crudService, ParameterBag $parameterBag, Fis07200LivroMagneticoService $serviceLivroMagnetico) {
        $this->serviceLivroMagnetico = $serviceLivroMagnetico;
        parent::__construct($crudService, $parameterBag);
    }

    public function deletaLayoutCFOPLivroMag(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->serviceLivroMagnetico->deletaLayoutCFOPLivroMag($row['CDLIVROMAG']);
    }
    public function deletaCadastroTipo(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->serviceLivroMagnetico->deletaCadastroTipo($row['CDLIVROMAG']);
    }
    public function deletaCadastroLayout(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->serviceLivroMagnetico->deletaCadastroLayout($row['CDLIVROMAG']);
    }

    public function replicaTipoDocumentoCFOP(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->serviceLivroMagnetico->replicaTipoDocumentoCFOP($row['CDLIVROMAGORIG'],$row['CDLIVROMAGDEST']);
    }
       public function replicaCadastroTipo(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->serviceLivroMagnetico->replicaCadastroTipo($row['CDLIVROMAGORIG'],$row['CDLIVROMAGDEST']);
    }
    
    public function importaLayoutCFOPLivroMag(DTO\Request\Row $request, DTO\Response $response){
        $requestRow = $request->getRow();
        $data = $requestRow["DATA"];
        $cdlivromag = $requestRow["CDLIVROMAG"];
        $cdlayout = "";
        foreach ($data as $row) {
            if (empty($cdlayout) || $cdlayout != $row['CDLAYOUTLMAG']){
                $this->serviceLivroMagnetico->saveLayoutLivroMag($row, $cdlivromag);
                $cdlayout = $row['CDLAYOUTLMAG'];
            }
            $this->serviceLivroMagnetico->saveCFOPLayoutLivroMag($row, $cdlivromag);
        }
    }

    public function deletaGeneroItemProduto(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->serviceLivroMagnetico->deletaGeneroItemProduto($row['CDLIVROMAG']);
    }

    public function replicaGeneroTipoItemProduto(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->serviceLivroMagnetico->replicaGeneroTipoItemProduto($row['CDLIVROMAGORIG'],$row['CDLIVROMAGDEST']);
    }
    
    public function deletarLivMag(DTO\Request\Row $request, DTO\Response $response){
        try{
 
            $row = $request->getRow()['Row'];
            $this->serviceLivroMagnetico->deletarLivMag($row);
            
        }catch(\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function deletarCfopLayout(DTO\Request\Row $request, DTO\Response $response){
        try{
            
            $row = $request->getRow()['Row'];
            $this->serviceLivroMagnetico->deletarCfopLayout($row);

            
        }catch(\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    public function deletarCfopTipo(DTO\Request\Row $request, DTO\Response $response){
        try{
            
            $row = $request->getRow()['Row'];
            $this->serviceLivroMagnetico->deletarCfopTipo($row);

            
        }catch(\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }


    public function cadastraGenTipoItemProdAutomatico(DTO\Request\Row $request, DTO\Response $response){
        try{
            $requestRow = $request->getRow();
            $row = $requestRow["ROW"];
            $cdlivromag = $requestRow["CDLIVROMAG"];
            $this->serviceLivroMagnetico->cadastraGenTipoItemProdAutomatico($row, $cdlivromag);
        }catch(\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function generoProd(DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $this->serviceLivroMagnetico->generoProd( $row );
        }catch(\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
}

